<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <!-- <lenna-loading v-show="isLoading"></lenna-loading> -->
    <div>
      <h3 class="text-primary">Integrate with Webchat</h3>
      <hr>
      <form @submit.prevent="submitForm">
        <div class="form-group">
          <span class="text-muted">Include Lenna Webchat plugin on your web page.</span>
          <small>Add the following code towards the end of the head section on your page</small>
        </div>

        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Lenna Webchat plugin</strong>
          <div class="col-sm-10">
            <textarea
              type="text"
              class="form-control"
              id="plugin-script"
              v-model="this.form.pluginScript"
              readonly
              rows="5"
            ></textarea>
          </div>
          <div class="col-sm-2">
            <button
              class="btn btn-rounded btn-primary"
              @click.prevent="handleCopy('#plugin-script')"
            >Copy</button>
          </div>
        </div>
        <br>
        <div class="form-group">
          <span class="text-muted">Initialize Lenna Webchat with your App Id</span>
        </div>

        <div class="form-group row">
          <strong class="col-sm-12 col-form-label">Initialize Script</strong>
          <div class="col-sm-10">
            <textarea
              type="text"
              class="form-control"
              id="init-script"
              v-model="this.form.initScript"
              readonly
              rows="2"
            ></textarea>
          </div>
          <div class="col-sm-2">
            <button
              class="btn btn-rounded btn-primary"
              @click.prevent="handleCopy('#init-script')"
            >Copy</button>
          </div>
        </div>
        <br>
        <div class="form-group row">
          <input type="hidden" v-model="form.status">
          <div class="col-sm-6">
            <button
              type="button"
              class="btn btn-rounded btn-block"
              :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
              :disabled="!form.status"
              @click="disconnectChannel"
            >Disconnect</button>
          </div>
          <div class="col-sm-6">
            <button
              type="submit"
              class="btn btn-rounded btn-block btn-primary"
            >{{(form.status) ? 'Update': 'Connect'}}</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
export default {
  data() {
    return {
      form: {
        pluginScript:
          "var a = ['c2NyaXB0', 'c3Jj', 'aHR0cHM6Ly9hcHAubGVubmEuYWkvd2ViY2hhdC9sZW5uYS1pbml0Lmpz', 'Y3JlYXRlRWxlbWVudA==', 'aHR0cHM6Ly9hcHAubGVubmEuYWkvd2ViY2hhdC9hcHAuanM=', 'aGVhZA==', 'YXBwZW5kQ2hpbGQ=']; var b = function (c, d) { c = c - 0x0; var e = a[c]; if (b['cOTzad'] === undefined) { (function () { var f = function () { var g; try { g = Function('return\x20(function()\x20' + '{}.constructor(\x22return\x20this\x22)(\x20)' + ');')(); } catch (h) { g = window; } return g; }; var i = f(); var j = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/='; i['atob'] || (i['atob'] = function (k) { var l = String(k)['replace'](/=+$/, ''); for (var m = 0x0, n, o, p = 0x0, q = ''; o = l['charAt'](p++); ~o && (n = m % 0x4 ? n * 0x40 + o : o, m++ % 0x4) ? q += String['fromCharCode'](0xff & n >> (-0x2 * m & 0x6)) : 0x0) { o = j['indexOf'](o); } return q; }); }()); b['VlQwuD'] = function (r) { var s = atob(r); var t = []; for (var u = 0x0, v = s['length']; u < v; u++) { t += '%' + ('00' + s['charCodeAt'](u)['toString'](0x10))['slice'](-0x2); } return decodeURIComponent(t); }; b['VRYblr'] = {}; b['cOTzad'] = !![]; } var w = b['VRYblr'][c]; if (w === undefined) { e = b['VlQwuD'](e); b['VRYblr'][c] = e; } else { e = w; } return e; }; var lennawebchat = document['createElement'](b('0x0')); lennawebchat[b('0x1')] = b('0x2'); var app = document[b('0x3')](b('0x0')); app[b('0x1')] = b('0x4'); document[b('0x5')]['appendChild'](lennawebchat); document[b('0x5')][b('0x6')](app);",
        initScript: `lennawebchat.onload = function () {LennaWebchatInit(${
          this.$store.getters.appId.hashed
        })};`,
        status: false,
        channelName: "webchat"
      }
    };
  },
  computed: {},
  methods: {
    handleCopy(selector) {
      let copyCode = document.querySelector(selector);
      copyCode.setAttribute("type", "text");
      copyCode.select();
      document.execCommand("copy");
    },
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "webchat");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      let validated = await this.$validator.validateAll();

      if (validated) {
        try {
          let formData = {
            ...this.form,
            status: true,
            webhookUrl: this.webhookUrl
          };
          let response = await this.$axios.post(
            `api/${this.$store.getters.appId.hashed}/integrate`,
            formData
          );
          this.form.status = true;

          this.$refs.lennaModal.show("info", "Success", response.data.message);

          EventBus.$emit("toggleStatusMain", "webchat");
        } catch (error) {
          this.$refs.lennaModal.show("alert", "Error", "Something wrong!");
        }
      } else {
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          "You must correct your form first"
        );
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "webchat";
      }).integration;

      if (channelData != null) {
        this.form.accessToken = channelData.integration_data.accessToken;
        // this.form.secretKey = channelData.integration_data.secretKey
        this.form.status = channelData.status;
      }
    }
  },
  mounted() {
    this.fetchData();

    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss">
.component-container {
  position: relative;
}
</style>
